<?php
class ControllerExtensionModuleSberbankId extends Controller {

	private $error = array();
	private $sberbank_id;

	public function install() {
		$this->load->model('extension/module/sberbank_id');

		$this->model_extension_module_sberbank_id->install();
	}

	public function uninstall() {
		$this->load->model('extension/module/sberbank_id');

		$this->model_extension_module_sberbank_id->uninstall();
	}

	public function index() {
		$this->load->language('extension/module/sberbank_id');

		$this->load->model('setting/setting');
		$this->load->model('design/layout');

		$this->document->setTitle($this->language->get('heading_title'));

        $library = 'sberbank_id';
        $file = DIR_SYSTEM . 'library/' . str_replace('../', '', (string)$library) . '.php';

        if (file_exists($file)) {
            include_once($file);
        } else {
            trigger_error('Error: Could not load library ' . $file . '!');
            exit();
        }
        $this->sberbank_id = new Sberbank\sberbank_id_handler();

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
        	if (empty($this->request->post['module_sberbank_id_scopes']) ) {
        		$this->request->post['module_sberbank_id_scopes'] = ['phone' => 'off'];
        	}
			$this->model_setting_setting->editSetting('module_sberbank_id', $this->request->post);
			$this->makeSert($this->request->post['module_sberbank_id_sert_password']);
			$this->session->data['success'] = $this->language->get('text_success');
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('bc_heading_title'),
			'href' => $this->url->link('extension/module/sberbank_id', 'user_token=' . $this->session->data['user_token'], true),
			'separator' => ' :: '
		);

		$data['action'] = $this->url->link('extension/module/sberbank_id', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		$data['user_token'] = $this->session->data['user_token'];


		
		if (isset($this->request->post['module_sberbank_id_client_id'])) {
			$data['module_sberbank_id_client_id'] = $this->request->post['module_sberbank_id_client_id'];
		} elseif ($this->config->get('module_sberbank_id_client_id')) {
			$data['module_sberbank_id_client_id'] = $this->config->get('module_sberbank_id_client_id');
		} else {
			$data['module_sberbank_id_client_id'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_client_secret'])) {
			$data['module_sberbank_id_client_secret'] = $this->request->post['module_sberbank_id_client_secret'];
		} elseif ($this->config->get('module_sberbank_id_client_secret')) {
			$data['module_sberbank_id_client_secret'] = $this->config->get('module_sberbank_id_client_secret');
		} else {
			$data['module_sberbank_id_client_secret'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_pkce'])) {
			$data['module_sberbank_id_pkce'] = $this->request->post['module_sberbank_id_pkce'];
		} elseif ($this->config->get('module_sberbank_id_pkce')) {
			$data['module_sberbank_id_pkce'] = $this->config->get('module_sberbank_id_pkce');
		} else {
			$data['module_sberbank_id_pkce'] = 'on';
		}
		if (isset($this->request->post['module_sberbank_id_personal'])) {
			$data['module_sberbank_id_personal'] = $this->request->post['module_sberbank_id_personal'];
		} elseif ($this->config->get('module_sberbank_id_personal')) {
			$data['module_sberbank_id_personal'] = $this->config->get('module_sberbank_id_personal');
		} else {
			$data['module_sberbank_id_personal'] = 'on';
		}
		if (isset($this->request->post['module_sberbank_id_fast'])) {
			$data['module_sberbank_id_fast'] = $this->request->post['module_sberbank_id_fast'];
		} elseif ($this->config->get('module_sberbank_id_fast')) {
			$data['module_sberbank_id_fast'] = $this->config->get('module_sberbank_id_fast');
		} else {
			$data['module_sberbank_id_fast'] = 'on';
		}

		if (isset($this->request->post['module_sberbank_id_api_version'])) {
			$data['module_sberbank_id_api_version'] = $this->request->post['module_sberbank_id_api_version'];
		} elseif ($this->config->get('module_sberbank_id_api_version')) {
			$data['module_sberbank_id_api_version'] = $this->config->get('module_sberbank_id_api_version');
		} else {
			$data['module_sberbank_id_api_version'] = '3.0.0';
		}

		if (isset($this->request->post['module_sberbank_id_web_to_app'])) {
			$data['module_sberbank_id_web_to_app'] = $this->request->post['module_sberbank_id_web_to_app'];
		} elseif ($this->config->get('module_sberbank_id_web_to_app')) {
			$data['module_sberbank_id_web_to_app'] = $this->config->get('module_sberbank_id_web_to_app');
		} else {
			$data['module_sberbank_id_web_to_app'] = 'on';
		}
		if (isset($this->request->post['module_sberbank_id_scopes'])) {
			$data['module_sberbank_id_scopes'] = $this->request->post['module_sberbank_id_scopes'];
		} elseif ($this->config->get('module_sberbank_id_scopes')) {
			$data['module_sberbank_id_scopes'] = $this->config->get('module_sberbank_id_scopes');
		} else {
			$data['module_sberbank_id_scopes'] = ['name' => 'on','email' => 'on'];
		}

		if (isset($this->request->post['module_sberbank_id_module_sberbank_id_sert_file'])) {
			$data['module_sberbank_id_module_sberbank_id_sert_file'] = $this->request->post['module_sberbank_id_module_sberbank_id_sert_file'];
		} elseif ($this->config->get('module_sberbank_id_module_sberbank_id_sert_file')) {
			$data['module_sberbank_id_module_sberbank_id_sert_file'] = $this->config->get('module_sberbank_id_module_sberbank_id_sert_file');
		} else {
			$data['module_sberbank_id_module_sberbank_id_sert_file'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_sert_password'])) {
			$data['module_sberbank_id_sert_password'] = $this->request->post['module_sberbank_id_sert_password'];
		} elseif ($this->config->get('module_sberbank_id_sert_password')) {
			$data['module_sberbank_id_sert_password'] = $this->config->get('module_sberbank_id_sert_password');
		} else {
			$data['module_sberbank_id_sert_password'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_button_size'])) {
			$data['module_sberbank_id_button_size'] = $this->request->post['module_sberbank_id_button_size'];
		} elseif ($this->config->get('module_sberbank_id_button_size')) {
			$data['module_sberbank_id_button_size'] = $this->config->get('module_sberbank_id_button_size');
		} else {
			$data['module_sberbank_id_button_size'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_button_form'])) {
			$data['module_sberbank_id_button_form'] = $this->request->post['module_sberbank_id_button_form'];
		} elseif ($this->config->get('module_sberbank_id_button_form')) {
			$data['module_sberbank_id_button_form'] = $this->config->get('module_sberbank_id_button_form');
		} else {
			$data['module_sberbank_id_button_form'] = '';
		}

		if (isset($this->request->post['module_sberbank_id_button_style'])) {
			$data['module_sberbank_id_button_style'] = $this->request->post['module_sberbank_id_button_style'];
		} elseif ($this->config->get('module_sberbank_id_button_style')) {
			$data['module_sberbank_id_button_style'] = $this->config->get('module_sberbank_id_button_style');
		} else {
			$data['module_sberbank_id_button_style'] = '';
		}


        if (isset($this->request->post['module_sberbank_id_status'])) {
			$data['module_sberbank_id_status'] = $this->request->post['module_sberbank_id_status'];
		} else {
			$data['module_sberbank_id_status'] = $this->config->get('module_sberbank_id_status');
		}


		// ERRORS

        if (isset($this->error['error_client_id'])) {
            $data['error']['client_id'] = $this->error['error_client_id'];
        } else {
            $data['error']['client_id'] = '';
        }

        if (isset($this->error['error_client_secret'])) {
            $data['error']['client_secret'] = $this->error['error_client_secret'];
        } else {
            $data['error']['client_secret'] = '';
        }

        if (isset($this->error['error_oauth_token'])) {
            $data['error']['oauth_token'] = $this->error['error_oauth_token'];
        } else {
            $data['error']['oauth_token'] = '';
        }

        if (isset($this->error['error_oauth_token_secret'])) {
            $data['error']['oauth_token_secret'] = $this->error['error_oauth_token_secret'];
        } else {
            $data['error']['oauth_token_secret'] = '';
        }

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/sberbank_id', $data));
	}

	protected function validate() {
		if(isset($this->request->post['module_sberbank_id_client_id'])) {
			$this->request->post['module_sberbank_id_client_id'] = trim($this->request->post['module_sberbank_id_client_id']);
		}
		if(isset($this->request->post['module_sberbank_id_client_secret'])) {
			$this->request->post['module_sberbank_id_client_secret'] = trim($this->request->post['module_sberbank_id_client_secret']);
		}
		if (!$this->user->hasPermission('modify', 'extension/module/sberbank_id')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
        if (isset($this->request->post['module_sberbank_id_status']) && $this->request->post['module_sberbank_id_status'] == 1) {
            if (isset($this->request->post['module_sberbank_id_client_id']) && empty($this->request->post['module_sberbank_id_client_id']) ) {
                $this->error['error_client_id'] = $this->language->get('error_client_id');
            }
            if (isset($this->request->post['module_sberbank_id_client_secret']) && empty($this->request->post['module_sberbank_id_client_secret']) ) {
                $this->error['error_client_secret'] = $this->language->get('error_client_secret');
            }
        }
        if(!isset($this->request->post['module_sberbank_id_pkce'])) {
    		$this->request->post['module_sberbank_id_pkce'] = 'off';
    	}
    	if(!isset($this->request->post['module_sberbank_id_fast'])) {
    		$this->request->post['module_sberbank_id_fast'] = 'off';
    	}
    	if(!isset($this->request->post['module_sberbank_id_personal'])) {
    		$this->request->post['module_sberbank_id_personal'] = 'off';
    	}
    	if(!isset($this->request->post['module_sberbank_id_web_to_app'])) {
    		$this->request->post['module_sberbank_id_web_to_app'] = 'off';
    	}
    	


		return !$this->error;
	}
	protected function makeSert($password) {
		if(isset($_FILES['module_sberbank_id_sert_file']) && $_FILES['module_sberbank_id_sert_file']['size'] > 0) {
			$file_parts = pathinfo($_FILES['module_sberbank_id_sert_file']['name']);
			if($file_parts['extension'] == 'p12') {				
				$this->sberbank_id->setSertificatePassword($password);
				$this->sberbank_id->sertificate_crop($_FILES['module_sberbank_id_sert_file']['tmp_name']);
			} else {
				$sert_upload_error = true;
			}
		}
	}

	
}